#include "myIncludes.h"

static char *colorStrings[LastColor] = 
{ "Black", "White", "Red", "Cyan", "Green", "Orange", "Yellow", "Violet", "Brown", "Gray" };


void SetupColors(int _useMono)
{
  XColor color, retColor;
  int i;

  if ((DefaultDepth(TheDisplay, TheScreenNumber) < 8) || _useMono)
  {
    colors[Black] = BlackPixelOfScreen(TheScreen);
    for(i=White;i<Brown;i++)
      colors[i] = WhitePixelOfScreen(TheScreen);
    ThePenColor = TheBGColor;
  }
  else
  {
    if (XAllocNamedColor(TheDisplay, DefaultColormap(TheDisplay, TheScreenNumber),
      *colorStrings, &color, &retColor))
      colors[Black] = color.pixel;
    else
      colors[Black] = BlackPixelOfScreen(TheScreen);
    
    for(i=White;i<=(LastColor-1);i++)
      if (XAllocNamedColor(TheDisplay, DefaultColormap(TheDisplay, TheScreenNumber),
        colorStrings[i], &color, &retColor))
      colors[i] = color.pixel;
    else
      colors[i] = WhitePixelOfScreen(TheScreen);
  }

}

     
