#include "myIncludes.h"

static int objectCompareFunc(ObjectClass _ob1, ObjectClass _ob2)
{
  return (_ob1 == _ob2);
}

void NewGame()
{
  TheLevel = 0;
  DestroyObject(TheFred);
  DestroyGameList();
  TheFred = CreateObject(Fred);
  ResetMazes();
  InitRandom();
}

void NewLevel()
{
  int count;
  ListPtr lp;
  int i;
  ObjectClass object;
  char *ptr;

  TheLevel++;
  GameClock == 0;

  count = 0;
  while ( !count && (ReadMazeFile() == FALSE))
    count++;

  InitializeMaze();

  GameList = ListCreate(objectCompareFunc, NULL);

  ListAdd(&GameList, (caddr_t)TheFred, Head);

  for(i=0;i<NUM_GHOSTS;i++)
  { 
    TheGhost[i] = CreateObject(Ghost);
    ListAdd(&GameList, (caddr_t)TheGhost[i], Head);
  }

  TheFruit = CreateObject(Fruit);
  ListAdd(&GameList, (caddr_t)TheFruit, Head);

  Reset(&GameList);

  XClearArea(TheDisplay, TheWindow, 0, 0, TheWidth, TheHeight, TRUE);
}

void GameSetMode(Mode _theMode)
{
  TheMode = _theMode;
  if (TheMode == Demo)
    FredSetDemo();
  else
    FredSetReal();
 
  NewGame();
  NewLevel();
}

void DrawNoGame()
{
  XPoint point[12];

  point[0].x = TheWidth/2-100;
  point[0].y = TheHeight/2-100;
  point[1].x = point[0].x + 75;
  point[1].y = point[0].y + 100;
  point[2].x = point[0].x;
  point[2].y = point[0].y + 200;
  point[3].x = point[2].x + 25;
  point[3].y = point[2].y;
  point[4].x = point[0].x + 100;
  point[4].y = point[3].y - 75;
  point[5].x = point[0].x + 175;
  point[5].y = point[3].y;
  point[6].x = point[5].x + 25;
  point[6].y = point[5].y;
  point[7].x = point[0].x + 125;
  point[7].y = point[0].y + 100;
  point[8].x = point[0].x + 200;
  point[8].y = point[0].y;
  point[9].x = point[0].x + 175;
  point[9].y = point[0].y;
  point[10].x = point[0].x + 100;
  point[10].y = point[0].y + 75;
  point[11].x = point[0].x + 25;
  point[11].y = point[0].y;

  SETCOLOR(TheMazeGC, Yellow);

  XFillArc(TheDisplay, TheWindow, TheMazeGC, point[0].x, point[0].y,
    200, 200, 30*64, 300*64);

  SETCOLOR(TheMazeGC, Red);
  XFillPolygon(TheDisplay, TheWindow, TheMazeGC, point, 12, Convex, CoordModeOrigin);

}

void GameOver()
{
  NoGame = True;
  DestroyObject(TheFred);
  DrawNoGame();
}

void DestroyGameList()
{
  ListPtr lp;
  ObjectClass object;

  if (GameList)
  {
    lp = GameList->list;
 
    while(lp != (ListPtr)NULL)
    {
      object = (ObjectClass)lp->data;
      lp = lp->next;
      if (object->object.type == FredObject)
        continue;
      DestroyObject(object);
    }
 
    ListDestroy(&GameList);
  }
  GameList = ListCreate(objectCompareFunc, NULL);
}
