#include "myIncludes.h"

#include <X11/keysym.h>
#include <ctype.h>

void HandleKey(XKeyEvent *_xke)
{
  Display *display = _xke->display;
  Window window = _xke->window;
  KeySym keySym;
  int i;

  keySym = XKeycodeToKeysym(display, _xke->keycode, 0);
  if (keySym == NoSymbol)
    return;

  switch(keySym)
  {
    case XK_Left:
      if (GoodLeft(TheFred))
        TheFred->object.direction = Left;
      break;
    case XK_Up:
      if (GoodUp(TheFred))
        TheFred->object.direction = Up;
      break;
    case XK_Down:
      if (GoodDown(TheFred))
        TheFred->object.direction = Down;
      break;
    case XK_Right:
      if (GoodRight(TheFred))
        TheFred->object.direction = Right;
      break;
    case XK_q:
    case XK_Q:
      ShutDown(display);
      break;
    case XK_i:
    case XK_I:
      XIconifyWindow(display, window, DefaultScreen(display));
      break;
    case XK_b:
    case XK_B:
      XBell(display, 0);
      break;
    case XK_D:
    case XK_d:
      NoGame = FALSE;
      GameSetMode(Demo);
      StatusSetMode(Demo);
      break;
    case XK_S:
    case XK_s:
      NoGame = FALSE;
      GameSetMode(Real);
      StatusSetMode(Real);
      break;
    default:
      break;
  }
}
