#include "myIncludes.h"

#include "fred.xbm"

#define APPNAME "XFred"

static int Paused = FALSE;
int NoGame = FALSE;

void ShutDown(Display *_theDisplay)
{
  XFreePixmap(_theDisplay, TheIcon);
  StatusShutdown();
  XFlush(_theDisplay);
  XCloseDisplay(_theDisplay);
  printf("Have a nice day. -- JLC\n");
  exit(0);
}

static void processEvents(Display *_theDisplay)
{
  XEvent event;

  while(TRUE)
  {
    while (!XPending(TheDisplay) && !Paused && !NoGame)
      ProcessGameList(&GameList);

    XNextEvent(_theDisplay, &event);
    switch(event.type)
    {
      case KeyPress:
        HandleKey((XKeyEvent *)&event);
        break;
      case Expose:
        {
          XExposeEvent *ee;
          ee = (XExposeEvent *)&event;
          if (ee->window == TheWindow)
          {
            DrawMaze();
            ExposeGameList(&GameList);
            if (NoGame)
              DrawNoGame();
          }
          else
            StatusExpose();
        break;
        }
      case LeaveNotify:
        Paused = TRUE;
        break;
      case EnterNotify:
        Paused = FALSE;
        break;
      case ClientMessage:
        ShutDown(_theDisplay);
        break;
    }
    XFlush(_theDisplay);
    if (!Paused && !NoGame)
      ProcessGameList(&GameList);
  }
}

static void selectEvents(Display *_theDisplay, Window _theWindow)
{
  XSelectInput(_theDisplay, _theWindow, 
    KeyPressMask | 
    ExposureMask | 
    LeaveWindowMask | 
    EnterWindowMask);
}

main(int argc, char *argv[])
{
  int i;
  int count;
  XWMHints wmHints;
  XSizeHints sizeHints;

  if ((TheDisplay = XOpenDisplay(NULL)) == (Display *)NULL)
  {
    printf("%s unable to open display %s...\n", XDisplayName(NULL));
    printf("Have a nice day. -- JLC\n");
    return 0;
  } 

  TheScreen = DefaultScreenOfDisplay(TheDisplay);
  TheScreenNumber = DefaultScreen(TheDisplay);

/* 
** To make this a small winodow make this false.
*/

  if ((WidthOfScreen(TheScreen) > BIGWIDTH) && (HeightOfScreen(TheScreen) > BIGHEIGHT))
  {
    sizeHints.width = BIGWIDTH;
    sizeHints.height = BIGWIDTH;
  }
  else
  {
    sizeHints.width = SMALLWIDTH;
    sizeHints.height = SMALLHEIGHT;
  }

  sizeHints.min_width = sizeHints.width;
  sizeHints.min_height = sizeHints.height;
  sizeHints.max_width = sizeHints.width;
  sizeHints.max_height = sizeHints.height;

  TheWidth = sizeHints.width;
  TheHeight = sizeHints.height;
  TheBoxWidth = sizeHints.width/MAZE_WIDTH;
  TheBoxHeight = sizeHints.width/MAZE_HEIGHT;

  sizeHints.x = 0;
  sizeHints.y = 0;
  sizeHints.flags = USPosition | PSize | PMinSize | PMaxSize; 

  TheWindow = XCreateSimpleWindow(TheDisplay, DefaultRootWindow(TheDisplay), sizeHints.x, sizeHints.y,
    sizeHints.width, sizeHints.height, 0, 0, 0);

  TheIcon = XCreateBitmapFromData(TheDisplay, TheWindow, fred_bits, fred_width, fred_height);
    
  wmHints.input = TRUE;
  wmHints.icon_pixmap = TheIcon;
  wmHints.flags = InputHint | IconPixmapHint;
  XSetWMHints(TheDisplay, TheWindow, &wmHints);
  XSetNormalHints(TheDisplay, TheWindow, &sizeHints);
  XStoreName(TheDisplay, TheWindow, APPNAME); 
  XSetIconName(TheDisplay, TheWindow, APPNAME);

  selectEvents(TheDisplay, TheWindow);

  XMapRaised(TheDisplay, TheWindow);

  TheBackgroundGC = XCreateGC(TheDisplay, TheWindow, NULL, 0);
  TheMazeGC = XCreateGC(TheDisplay, TheWindow, NULL, 0);

  SetupColors(FALSE);

  SETCOLOR(TheBackgroundGC, TheBGColor);

  StatusInit(&sizeHints);

  NewGame();
  NewLevel();

  processEvents(TheDisplay);
}
