#include <memory.h>

#include "myIncludes.h"
#include "object.h"

ObjectClassRec object = 
{
  {
    GenericObject,
    NULL,
    FALSE,
    sizeof(ObjectClassRec),
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    0.0,
    Black,
    (GC)NULL,
    0.0,
    0.0,
    Still,
    Normal,
    0,
  },
};

ObjectClass Object = (ObjectClass)&object;

ObjectClass CreateObject(ObjectClass _object)
{
  ObjectClassRec *newObject;
  ObjectClass newObjectPtr;

  newObject = (ObjectClassRec *)malloc(_object->object.size);
  newObjectPtr = newObject;

  if (!(_object->object.classInited))
  {
    XGCValues xgcv;
    xgcv.background = colors[Black];
    xgcv.foreground = colors[White];
    _object->object.gc = XCreateGC(TheDisplay, TheWindow, GCForeground | GCBackground, &xgcv);
    _object->object.classInited = TRUE;
    if (_object->object.classInit)
      _object->object.classInit();
  }

  bcopy(_object, newObjectPtr, _object->object.size);

  if ((*newObject).object.initialize)
    (*newObject).object.initialize(newObjectPtr);

  return newObjectPtr;
}

void DestroyObject(ObjectClass _object)
{
  free(_object);
}

void MoveObject(ObjectClass _object, double _x, double _y)
{
  _object->object.x = _x;
  _object->object.y = _y;
}
  
