#ifndef _object_h
#define _object_h

typedef struct _ObjectPart
{
  ObjectType type;
  void (*classInit)();
  int classInited;
  int size;
  void (*initialize)();
  void (*draw)();
  void (*unDraw)();
  void (*move)();
  int (*destroy)();
  void (*reset)();
  void (*postTurnFunc)();
  double moveInc;
  Color color;
  GC gc;
  double x, y;
  Direction direction;
  Speed speed;
  State state;
  int clock;
} ObjectPart;

typedef struct _ObjectClassRec
{
  ObjectPart object;
} ObjectClassRec;

typedef ObjectClassRec *ObjectClass;

extern ObjectClass Object;

#if NeedFunctionProtoTypes
extern ObjectClass CreateObject(ObjectClass _object);
extern void DestroyObject(ObjectClass _object);
extern void MoveObject(ObjectClass _object, double _x, double _y);
#else
extern ObjectClass CreateObject();
extern void DestroyObject();
extern void MoveObject();
#endif

#endif /* _object_h */
