#include "myIncludes.h"

static void Interact(
#if NeedFunctionProtoTypes
List *_gameList
#endif
);

void ProcessGameList(List *_gameList)
{
  ObjectClass object;
  ListPtr lp;

  GameClock++;

  if (TheFred->object.state == Alive)
    Interact(_gameList);

  lp = (*_gameList)->list;

  while(lp != (ListPtr)NULL)
  {
    object = (ObjectClass)lp->data;
    if(object != (ObjectClass)NULL)
    {
      if (object->object.move)
      {
        switch(object->object.speed)
        {
          case Turtle:
            if (GameClock % 3100)
              goto BreakOut;
            else
              break;
          case Slow:
            if (GameClock % 2100)
              goto BreakOut;
            else
              break;
          case Normal:
            if (GameClock % 1300)
              goto BreakOut;
            else
              break;
          case Fast:
            if (GameClock % 1000)
              goto BreakOut;
            else
              break;
          case Speedy:
            if (GameClock % 900)
              goto BreakOut;
            else
              break;
          case Gonzales:
            if (GameClock % 750)
              goto BreakOut;
            else
              break;
          case Warp9:
            if (GameClock % 350)
              goto BreakOut;
            else
              break;
          default:
            printf("AAAAAA! -> %d\n", object->object.type, object->object.move);
            goto BreakOut;
            break;
        }
        if (object->object.direction != Still)
        {
          object->object.unDraw(object);
          DrawMazeCharUnderObject(object);
          TunnelWarp(object);
        }
        object->object.move(object);

        object->object.draw(object);
        if (object->object.postTurnFunc)
          object->object.postTurnFunc(object);
      }
    }
BreakOut:
    lp = lp->next;
  }

  StatusUpdate(&((FredClass)TheFred)->fred.men, ((FredClass)TheFred)->fred.score);

}

/*
** Interact the f-man with the list
*/

#define CLOSE(a,b) ((ROUND(a->object.x) == ROUND(b->object.x)) && (ROUND(a->object.y) == ROUND(b->object.y)))

static void Interact(List *_gameList)
{
  ListPtr lp;
  ObjectClass object;
  int cont = TRUE;

  lp = (*_gameList)->list;
 
  while((lp != (ListPtr)NULL) && cont)
  {
    object = (ObjectClass)lp->data;
    if (object->object.type == FredObject)
    {
      lp = lp->next;
      continue;
    }

    if (CLOSE(TheFred, object))
    {
      switch(object->object.type)
      {
        case GhostObject:
        {
          GhostClass ghost;
          ghost = (GhostClass)object;
          switch(ghost->object.state)
          {
            case Alive:
              TheFred->object.destroy(TheFred);
              cont = FALSE;
              break;
            case Afraid:
            case Blink:
              ((FredClass)TheFred)->fred.score += object->object.destroy(object);
              break;
            default: 
              break;
          }
          break;
        }
        case FruitObject:
          if (object->object.state == Alive) 
            ((FredClass)TheFred)->fred.score += object->object.destroy(object);
          break;
      }
    }
    lp = lp->next;
  }
}

void Reset(List *_gameList)
{
  ListPtr lp;
  ObjectClass object;
  int i;

  lp = (*_gameList)->list;

 i = 0;
  while(lp != (ListPtr)NULL)
  {
    object = (ObjectClass)lp->data;
    object->object.unDraw(object);
    DrawMazeCharUnderObject(object);
    object->object.reset(object);
    lp = lp->next;
  }
}
