#include "myIncludes.h"

static XFontStruct *TheFontStruct;
static unsigned int StatusClock = 0;
static unsigned int CurrentLine;
static unsigned int TheTextHeight;
static unsigned int NumLinesCanShow;
static int CurrentOffset;
static Mode TheStatMode = Demo;
static int MenLeft = 4;
static int Score = 0;
static int NextPacMan = 25000;

static char TheScoreString[10];

#define OFFSET 20

#define WINNAME "XFred Status"
#define MULTIPLIER 10

#if NeedFunctionProtoTypes
static void reset();
static void drawText(GC _theGC);
static void moveText();
static void selectEvents(Display *_theDisplay, Window _theWindow);
static void exposeFancyWindow(GC _theGC);
static void exposeScore(GC _theGC);
static void exposeMenLeft();
#else
static void reset();
static void drawText();
static void moveText();
static void selectEvents();
static void exposeFancyWindow();
static void exposeScore();
static void exposeMenLeft();
#endif


static char *MyText[] = 
{
  "XFRED",
  " ",
  " ",
  " ",
  "A long time ago...",
  " ",
  " ",
  "In a galaxy not too far away...",
  " ",
  "On planet X (X -- get it?)...",
  " ",
  "Lived a creature who loved to munch.",
  " ",
  " ",
  "That creature was...",
  " ",
  " ",
  " ",
  "Fred.",
  " ",
  " ",
  "Instructions",
  " ",
  "Guide Fred around using the arrow keys.",
  "Eat the little dots for points.",
  "Eat the big squares for power to eat the ghosts.",
  "Eat the fruits for points.",
  " ",
  "Stay away from the ghosts.",
  " ",
  "Use the 'd' or 'D' key to enter demo mode.",
  "Use the 's' or 'S' key to start a new game.",
  "Use the 'q' or 'Q' key to quit XFred.",
  "Use the 'b' or 'B' key to beep the terminal.",
  " ",
  "(I don't know about the beeping thing either,",
  "but you might be bored...)",
  " ",
  " ",
  " ",
  "XFred was written and designed by",
  "John L. Cwikla, 1992",
  " ",
  " ",
  "Special thanks to:",
  "K.J.",
  " ",
  " ",
  "(He kept saying, \"Sure it looks nice,\"",
  "\"but when will it be FINISHED?\")",
  " ",
  " ",
  "Disclaimer:",
  " ",
  "John L. Cwikla makes no warranty on the",
  "fitness of this product",
  "nor is he responsible for any damage or",
  "mischance caused by it.",
  " ",
  " ",
  "(nor hours of CPU wasted)",
  " ",
  " ",
  " ",
  "Copying and Distribution:",
  " ",
  "Feel free to copy/modify/distribute",
  "this source freely as long",
  "as this notice remains in tact, it",
  "is not sold for money, and",
  "that John L. Cwikla is given credit",
  "of original authorship and design.",
  " ",
  " ",
  "(i.e., leave my name up in lights)",
  " ",
  " ",
  "John L. Cwikla",
  "cwikla@wri.com",
  " ",
};

static void reset()
{
  CurrentLine = 1;
  StatusClock = 0;
  CurrentOffset = STAT_WIN_HEIGHT;
}

static void drawText(GC _theGC)
{
  unsigned int x, y, width;
  int length;
  int start, finish;
  int space;
  int i;
  char *string;
  int numLines;

  start = CurrentLine-1;
  numLines = (STAT_WIN_HEIGHT-CurrentOffset)/(TheTextHeight*1.5);

  finish = MIN(start+numLines, NUM(MyText));
  space = TheTextHeight * 1.5;

  y = CurrentOffset;

  for(i=start;i<finish;i++)
  {
    string = MyText[i];
    if (*string != ' ')
    {
      length = strlen(string);
      width = XTextWidth(TheFontStruct, string, length);
      x = STAT_WIN_WIDTH/2 - width/2;
      XDrawString(TheDisplay, TheStatusWindow, _theGC, x, y, string, length);
    }
      y += space; 
  }

  if (start == (NUM(MyText)-1))
    reset();
}

static void moveText()
{
  StatusClock++;

  if (StatusClock % 500)
    return;

  SETCOLOR(TheStatusGC, White);
  drawText(TheStatusGC);

  CurrentOffset -= 2;

  if (CurrentOffset <= 0)
  {
    CurrentOffset = TheTextHeight * 1.5;
    CurrentLine =  (CurrentLine == NUM(MyText)) ? 1 : CurrentLine + 1;
  }

  SETCOLOR(TheStatusGC, Black);
  drawText(TheStatusGC);
}

static void selectEvents(Display *_theDisplay, Window _theWindow)
{
  XSelectInput(_theDisplay, _theWindow, KeyPressMask | ExposureMask | ButtonPressMask);
}

static void exposeFancyWindow(GC _theGC)
{
  XFillRectangle(TheDisplay, TheStatusWindow, TheStatusGC, 0, 0, STAT_WIN_WIDTH, STAT_WIN_HEIGHT);
}

static void exposeScore(GC _theGC)
{
  DrawScore(_theGC, Score);
}

static void exposeMenLeft()
{
  int angle1, angle2;
  int x, y;
  int i;

  angle1 = 45*64;
  angle2 = 270*64;

  x = 45;
  y = STAT_WIN_HEIGHT*3/4;

  for(i=0;i<MenLeft;i++)
  {
    XFillArc(TheDisplay, TheStatusWindow, TheStatusGC, x, y,
      45, 45, angle1, angle2);
    x += 50;
  }

}

void StatusExpose()
{
  if (TheStatMode == Demo)
  {
    SETCOLOR(TheStatusGC, White);
    XFillRectangle(TheDisplay, TheStatusWindow, TheStatusGC, 0, 0, STAT_WIN_WIDTH, STAT_WIN_HEIGHT);
    SETCOLOR(TheStatusGC, Black);
    drawText(TheStatusGC);
  }
  else
  {
    SETCOLOR(TheStatusGC, Black);
    exposeFancyWindow(TheStatusGC);
    SETCOLOR(TheStatusGC, Blue);
    exposeScore(TheStatusGC);
    SETCOLOR(TheStatusGC, Yellow);
    exposeMenLeft();
  }
}

void StatusShutdown()
{
  XFreeFont(TheDisplay, TheFontStruct);
  XFreeGC(TheDisplay, TheStatusGC);
}

void StatusUpdate(int *_menLeft, int _score)
{
  if (TheStatMode == Demo)
  {
    moveText();
    return;
  }
  else
  if (_score != Score)
  {
    SETCOLOR(TheStatusGC, Black);
    exposeScore(TheStatusGC);
    SETCOLOR(TheStatusGC, Blue);
    Score = _score;
    exposeScore(TheStatusGC);
    if (Score > NextPacMan)
    {
      (*_menLeft)++;
      NextPacMan *= MULTIPLIER;
    }
  }

  if (*_menLeft != MenLeft)
  {
    SETCOLOR(TheStatusGC, Black);
    exposeMenLeft(TheStatusGC);
    SETCOLOR(TheStatusGC, Yellow);
    MenLeft = *_menLeft;
    exposeMenLeft(TheStatusGC);
  }
  
}

void StatusSetMode(Mode _theMode)
{
  if (TheStatMode != _theMode)
  {
    TheStatMode = _theMode;
    reset();
    XClearArea(TheDisplay, TheStatusWindow, 0, 0, STAT_WIN_WIDTH, STAT_WIN_HEIGHT, TRUE);
  }
}

void StatusInit(XSizeHints *_sizeHints)
{
  XWMHints wmHints;
  XGCValues xgcv; 

  _sizeHints->x += _sizeHints->width + 25;
  _sizeHints->width = STAT_WIN_WIDTH;
  _sizeHints->height = STAT_WIN_HEIGHT;
  _sizeHints->min_width = _sizeHints->width;
  _sizeHints->min_height = _sizeHints->height;
  _sizeHints->max_width = _sizeHints->width;
  _sizeHints->max_height = _sizeHints->height;
 
  _sizeHints->flags = USPosition | PSize | PMinSize | PMaxSize;
 
  TheStatusWindow = XCreateSimpleWindow(TheDisplay, DefaultRootWindow(TheDisplay), _sizeHints->x, _sizeHints->y,
    _sizeHints->width, _sizeHints->height, 0, 0, 0);

  wmHints.icon_pixmap = TheIcon; 
  wmHints.input = TRUE;
  wmHints.flags = InputHint | IconPixmapHint;
  XSetWMHints(TheDisplay, TheStatusWindow, &wmHints);
  XSetNormalHints(TheDisplay, TheStatusWindow, _sizeHints);
  XStoreName(TheDisplay, TheStatusWindow, WINNAME);
  XSetIconName(TheDisplay, TheStatusWindow, WINNAME);
 
  selectEvents(TheDisplay, TheStatusWindow);
 
  XMapRaised(TheDisplay, TheStatusWindow);

  TheFontStruct = XLoadQueryFont(TheDisplay, "fixed");

  xgcv.foreground = colors[Black];
  xgcv.font = TheFontStruct->fid;
  TheStatusGC = XCreateGC(TheDisplay, TheStatusWindow, GCForeground | GCFont, &xgcv);

  TheTextHeight = TheFontStruct->ascent + TheFontStruct->descent;

  NumLinesCanShow = (STAT_WIN_HEIGHT-OFFSET)/(TheTextHeight*1.5)-1;

  reset();
}

